'HotStuff.bas Copyright 2005 James J Keene PhD
'updated: Oct 7, 2005

$APPTYPE GUI: $TYPECHECK ON
$INCLUDE "DirTree.inc"
$INCLUDE "SortList.inc"
showconsole

defstr root_path, dir_tree, exe$, a$, b$, r$, s$, t$
defint iGO,iSHELL,iLEN,iEXE,iFILE,nFILES,nERR
DIM path as LIST
defstr ext$=".BAS"
defstr stuffpath$=curdir$

'optional command-line argument of source file extension
'USAGE:
'HotStuff c
'would search for .c files
a$=COMMAND$(1)
IF a$.Length THEN ext$="."+UCASE$(a$)

create f As FORM
  caption="HotStuff Compiler Tester 1.0e"
  icon="hotbasic.ico"
  width=420: height=240
  resizeable=false
  maximizebox=false
  onclose=f_close
  center
  create lab01 As LABEL
    top=10
    width=100
    caption="Compiler Directory"
  end create
  create ed01 As EDIT
    left=114: top=10
    width=148
    color=&HDDDDFF
  end create
  create lab02 As LABEL
    top=35
    width=100
    caption="Compiler Command"
  end create
  create ed02 As EDIT
    left=114: top=35
    width=148
    color=&HDDDDFF
  end create
  create lab03 As LABEL
    top=60
    width=100
    caption="Source File Path"
  end create
  create ed03 As EDIT
    left=114: top=60
    width=148
    color=&HFFFFCC
  end create
  create lab04 As LABEL
    top=85
    width=100
    caption="Command Arguments"
  end create
  create ed04 As EDIT
    left=114: top=85
    width=148
    color=&HCCFFCC
  end create

  create chk01 As CHECKBOX
    left=270: top=10
    width=200
    cursor=32649
    caption="Run compiled programs"
  end create
  create chk02 As CHECKBOX
    left=270: top=35
    width=130
    caption="Save results to file"
  end create
  create lab1 As LABEL
    left=270: top=60
    width=130
  end create
  create b As BUTTON
    style=b.style or &H1003
    left=270: top=85
    width=130
    caption="Start"
    onclick=b_click
  end create
  create lb As LISTBOX
    left=0: top=110
    width=f.clientwidth
    height=f.clientheight-128
  end create
  create SB as STATUSBAR
    caption="Idle..."
  end create
end create

s$.loadfromfile "hotstuff.ini"
ed01.text=s$.item(0)
ed02.text=s$.item(1)
ed03.text=s$.item(2)
ed04.text=s$.item(3)
s$.clear
f.showmodal
END

f_close:
IF iGO THEN return
IF chk02.checked THEN
  kill "hotstuff.dat"
  IF lb.itemcount THEN lb.savetofile "hotstuff.dat"
END IF
s$.clear
s$.additems ed01.text,ed02.text,ed03.text,ed04.text
s$.savetofile "hotstuff.ini"
app.terminate
return

b_click:
IF iGO THEN iGO=0: b.caption="Wait": return 
INC(iGO): b.caption="Stop"
root_path=ed03.text
IF NOT root_path.length THEN
  ShowMessage "No Files Directory"
  Goto b_exit
END IF
lab1.caption="Getting directory tree..."
s$=DirTree(root_path,&H37)
IF NOT iGO THEN Goto b_exit
lab1.caption="Sorting directory tree..."
DOEVENTS
dir_tree=SortList(s$): s$.clear
lab1.caption="Finding "+ext$+" files..."
DOEVENTS
dir_tree.position=0: path.clear: nFILES=0

next_file:
a$=dir_tree.readline
'select files with proper extension
IF a$.Length THEN
  s$=UCASE$(a$)  
  IF INSTR(s$,ext$) THEN INC(nFILES): path.writeline(a$)
  Goto next_file
END IF
dir_tree.clear: path.position=0
lab1.caption=str$(nFILES)+space+ext$+" source files"
IF NOT iGO THEN Goto b_exit
lb.clear
DOEVENTS
'set up utility strings
r$=ed01.text+ed02.text+space: a$=space+ed04.text
s$=" of "+STR$(nFILES)
iFILE=0: nERR=0
defdbl time=TIMER

next_prog:
b$=path.readline
IF NOT b$.Length THEN Goto b_exit
INC(iFILE)
lab1.caption="Source file "+STR$(iFILE)+s$
SB.caption=b$
'get .exe pathname and set iEXE flag
iLEN=b$.Length-ext$.length
exe$=LEFT$(b$, iLEN)+".exe"
IF FILEEXISTS(exe$) THEN iEXE=0 ELSE INC(iEXE)
DOEVENTS
'make command
t$=r$+b$
IF a$.Length>1 THEN t$.write(a$)
'do compile
iSHELL=SHELL t$
DOEVENTS
IF iSHELL THEN
  INC(nERR): lb.additems "Err "+STR$(iSHELL)+space+b$
ELSE
  IF chk01.checked THEN
    IF FILEEXISTS(exe$) THEN
      iLEN=INSTR(reverse$(exe$),"\")
      IF iLEN THEN DEC(iLEN)
      CHDIR LEFT$(exe$, exe$.length-iLEN) 'set working directory
      SB.text="Running "+exe$: SHELL exe$ 'run program
      CHDIR stuffpath$  'restore hotstuff working directory
    END IF
    SB.text=null: f.foreground
  END IF
END IF
DOEVENTS
'delete .exe if it did not already exist
IF iEXE THEN KILL(exe$) 
IF iGO THEN Goto next_prog

b_exit:
lab1.text=STR$(nERR)+" errors in "+STR$(iFILE)+" files"
time=TIMER-time
SB.text="Elapsed time = "+left$(str$(time),6)+" seconds"
b.caption="Start": b.checked=False
DOEVENTS: iGO=0
return
